/* 
 * 386iops.S -- My 1989 DOS 386 asm benchmark revisited
 * Last modified: 5 January 1998
 * This code is Copyright (C)1998 Nathan Laredo
 * May be freely distributed in unmodified form
 *
 * Special thanks to vbostrom for p6 optimization hints
 */
#ifdef linux
#include <asm/unistd.h>
#define DoSysCall1	int $0x80
#define DoSysCall2	int $0x80
#define DoSysCall3	int $0x80
#else
#include <sys/syscall.h>
#define __NR_signal	SYS_signal
#define __NR_setitimer	SYS_setitimer
#define __NR_write	SYS_write
#define __NR_exit	SYS_exit
#define DoSysCall3	call BSDSysCall3
#define DoSysCall2	call BSDSysCall2
#define DoSysCall1	call BSDSysCall1
#undef  SysCallType	int $0x80
#define SysCallType	lcall $7,$0
#endif

.data

expired: .byte 1, 2, 3, 4
Output: .asciz "0000000000 "
Return: .asciz "\r"

Intro1: .asciz "386IOPS v1.0  Last Revised 09 Jan 1998  (all values operations per second)\nADD        SUB        MUL        DIV        ROL        SHL        BSWAP\n" 

Message1: .asciz "\nFOR REFERENCE: Pentium @ 166 MHz:\n0236358280 0236477220 0017896940 0004013580 0143951460 0143918420 0075247380\nPentium II  @ 337.5 MHz:\n0421522660 0421492680 0067440940 0008646180 0313175040 0337074440 0301839540\n\nNathan Laredo (laredo@broked.net)\nPSC 1 BOX 709, 2401 Kelly Drive, Lackland AFB, TX 78236-5128\n"

.text
	.align 4
#ifdef linux
.global _start
#endif
_start:
	/* print intro and header lines */
	movl  $Intro1,%ecx
	call  print
	/* trap signal 2 to do call exit routine below */
	movl  $2,%ebx
	movl  $doexit,%ecx
	movl  $__NR_signal,%eax
	DoSysCall2
back:	call  setup
	.align 4
doadd:  addl  %eax,%ebx
	addl  %esi,%edi
	addl  %ebp,%edx
	addl  %eax,%ebx
	addl  %esi,%edi
	addl  %ebp,%edx
	addl  %eax,%ebx
	addl  %esi,%edi
	addl  %ebp,%edx
	addl  %eax,%ebx
	incl  %ecx
	addl  %esi,%edi
	addl  %ebp,%edx
	addl  %eax,%ebx
	addl  %esi,%edi
	addl  %ebp,%edx
	addl  %eax,%ebx
	addl  %esi,%edi
	addl  %ebp,%edx
	addl  %eax,%ebx
	addl  %esi,%edi
	incl  %ecx
	cmpl  $0,expired
	je    doadd
	call  output
	call  setup
	.align 4
dosub:  subl  %eax,%ebx
	subl  %esi,%edi
	subl  %ebp,%edx
	subl  %eax,%ebx
	subl  %esi,%edi
	subl  %ebp,%edx
	subl  %eax,%ebx
	subl  %esi,%edi
	subl  %ebp,%edx
	subl  %eax,%ebx
	incl  %ecx
	subl  %esi,%edi
	subl  %ebp,%edx
	subl  %eax,%ebx
	subl  %esi,%edi
	subl  %ebp,%edx
	subl  %eax,%ebx
	subl  %esi,%edi
	subl  %ebp,%edx
	subl  %eax,%ebx
	subl  %esi,%edi
	incl  %ecx
	cmpl  $0,expired
	je    dosub
	call  output
	xorl  %edx,%edx
	movl  $730410,%eax
	movl  $1,%ebx
	call  setup
	.align 4
domul:	mull  %ebx
	mull  %ebx
	mull  %ebx
	mull  %ebx
	mull  %ebx
	mull  %ebx
	mull  %ebx
	mull  %ebx
	mull  %ebx
	mull  %ebx
	incl  %ecx
	mull  %ebx
	mull  %ebx
	mull  %ebx
	mull  %ebx
	mull  %ebx
	mull  %ebx
	mull  %ebx
	mull  %ebx
	mull  %ebx
	mull  %ebx
	incl  %ecx
	cmpl  $0,expired
	je    domul
	call  output
	xorl  %edx,%edx
	movl  $730410,%eax
	movl  $1,%ebx
	call  setup
	.align 4
dodiv:	divl  %ebx
	divl  %ebx
	divl  %ebx
	divl  %ebx
	divl  %ebx
	divl  %ebx
	divl  %ebx
	divl  %ebx
	divl  %ebx
	divl  %ebx
	incl  %ecx
	divl  %ebx
	divl  %ebx
	divl  %ebx
	divl  %ebx
	divl  %ebx
	divl  %ebx
	divl  %ebx
	divl  %ebx
	divl  %ebx
	divl  %ebx
	incl  %ecx
	cmpl  $0,expired
	je    dodiv
	call  output
	call  setup
	.align 4
dorol:	roll  %eax
	roll  %ebx
	roll  %edx
	roll  %esi
	roll  %edi
	roll  %ebp
	roll  %eax
	roll  %ebx
	roll  %edx
	roll  %esi
	incl  %ecx
	roll  %eax
	roll  %ebx
	roll  %edx
	roll  %esi
	roll  %edi
	roll  %ebp
	roll  %eax
	roll  %ebx
	roll  %edx
	roll  %esi
	incl  %ecx
	cmpl  $0,expired
	je    dorol
	call  output
	call  setup
	.align 4
doshl: 
	shll  %eax
	shll  %ebx
	shll  %edx
	shll  %esi
	shll  %edi
	shll  %ebp
	shll  %eax
	shll  %ebx
	shll  %edx
	shll  %esi
	incl  %ecx
	shll  %eax
	shll  %ebx
	shll  %edx
	shll  %esi
	shll  %edi
	shll  %ebp
	shll  %eax
	shll  %ebx
	shll  %edx
	shll  %esi
	incl  %ecx
	cmpl  $0,expired
	je    doshl
	call  output
	call  setup
	.align 4
dobswap: 
	bswap %ecx
	bswap %eax
	bswap %ebx
	bswap %edx
	bswap %esi
	bswap %edi
	bswap %ebp
	bswap %ecx
	bswap %eax
	bswap %ebx
	incl  %ecx
	bswap %ecx
	bswap %eax
	bswap %ebx
	bswap %edx
	bswap %esi
	bswap %edi
	bswap %ebp
	bswap %ecx
	bswap %eax
	bswap %ebx
	incl  %ecx
	cmpl  $0,expired
	je    dobswap
	call  output
	movl  $Return,%ecx
	call  print
	jmp   back

	/* handle alarm: set expired flag, setup signal handler */
	.align 4
timeup:	incl  expired
	movl  $14,%ebx
	movl  $timeup,%ecx
	movl  $__NR_signal,%eax
	DoSysCall2
	ret

	/* setup an alarm to et expired flag in one second */
	/* clear iteration counter (%ecx) for benchmark */
	.align 4
setup:	call  timeup
	movl  $1,%ebx
	movl  $__NR_alarm,%eax
	DoSysCall2
	movl  $0,expired
	xorl  %ecx,%ecx
	ret

	/* convert counter %ecx to ascii -- multiply counter by 10 */
	.align 4
counttoascii:
	movl  %ecx,%eax
	movl  $10,%ebx
	movl  $9,%ecx		/* we have 9 digits to convert */
div10:  xorl  %edx,%edx		/* clear remainder */
	divl  %ebx		/* eax/ebx, remainder in edx, quot eax */
	addb  $0x30,%dl		/* convert remainder to ascii and store */
	movb  %dl,Output-1(%ecx)	/* store ascii digit */
	loop  div10		/* keep going for all 9 digits */
	ret

	/* write the string pointed to by %ecx to stdout */
	.align 4
print:  movl %ecx,%edx
        xorl %ebx,%ebx
        decl %edx
print_count:
        incl %edx
        cmpb (%edx),%bl
        jnz  print_count
        subl %ecx,%edx
        movl $__NR_write,%eax
	DoSysCall3
        ret

	/* output counter contained in %ecx */
	.align 4
output:
	call  counttoascii
	movl  $Output,%ecx
	call  print
	ret

	/* exit program, printing reference comparison message */
doexit:	movl  $Message1,%ecx
	call  print
	xorl  %ebx,%ebx
	movl  $__NR_exit,%eax
	DoSysCall1	/* exit here and never return */
	int   $3	/* trap out if we get to here */

	/* wrapper for bsd syscalls */
BSDSysCall3:
	pushl  %edx
BSDSysCall2:
	pushl  %ecx
BSDSysCall1:
	pushl  %ebx
	pushl  %eax
	lcall  $7,$0
	ret
